package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class EigenModesChain3 extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new EigenModesChain3(), 580, 580);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    linearChainOscillator1 = new physbeans.phys.LinearChainOscillator();
    springChainView1 = new physbeans.views.SpringChainView();
    eigenVectorFunction1 = new physbeans.func.EigenVectorFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSliderM = new physbeans.inout.VectorSlider();
    vectorSliderC = new physbeans.inout.VectorSlider();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    linearChainOscillator1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        linearChainOscillator1SourceChanged(evt);
      }
    });
    linearChainOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        linearChainOscillator1ValueChanged1(evt);
        linearChainOscillator1ValueChanged(evt);
      }
    });
    
    springChainView1.setXScale(0.15);
    springChainView1.setHideHugeSprings(true);
    springChainView1.setMassScale(0.8);
    springChainView1.setSpringScale(0.8);
    springChainView1.setSystem(linearChainOscillator1);
    springChainView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springChainView1SourceChanged(evt);
      }
    });
    
    eigenVectorFunction1.setNormType(2);
    eigenVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        eigenVectorFunction1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    objectPanel.setLayout(new java.awt.BorderLayout());
    
    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(4.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.setOpaque(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel);
    
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.X_AXIS));
    
    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(300, 142));
    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[]{true,true,true});
    oscilloscope1.setMaxY(1.05);
    oscilloscope1.setMinY(-1.05);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.EigenModesChain3", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.EigenModesChain3", currentLocale).getString("osciScale"));
    outputPanel.add(oscilloscope1);
    
    jPanel2.add(outputPanel);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));
    
    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    timer1.setDelay(20L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.EigenModesChain3", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });
    
    inputPanel.add(timer1);
    
    vectorSliderM.setCount(3);
    vectorSliderM.setDescription("m =");
    vectorSliderM.setInitialValues(DVector.valueOf("[1.0,1.0,1.0]"));
    vectorSliderM.setMaximum(5.0);
    vectorSliderM.setMinimum(1.0E-4);
    vectorSliderM.setUnit("kg");
    vectorSliderM.setVertical(false);
    vectorSliderM.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderMPropertyChange(evt);
      }
    });
    
    inputPanel.add(vectorSliderM);
    
    vectorSliderC.setDescription("c =");
    vectorSliderC.setInitialValues(DVector.valueOf("[1.0,1.0,1.0,1.0]"));
    vectorSliderC.setMaximum(5.0);
    vectorSliderC.setUnit("N/m");
    vectorSliderC.setVertical(false);
    vectorSliderC.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderCPropertyChange(evt);
      }
    });
    
    inputPanel.add(vectorSliderC);
    
    radioButtonBox1.setBoxLabel(new String[] {"1", "2", "3"});
    radioButtonBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.EigenModesChain3", currentLocale).getString("s2"));
    radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        radioButtonBox1ValueChanged(evt);
      }
    });
    
    inputPanel.add(radioButtonBox1);
    
    switchBox1.setBoxLabel(new String[] {"x1", "x2", "x3"});
    switchBox1.setSelected(new boolean[]{true,true,true});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.EigenModesChain3", currentLocale).getString("s1"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel.add(switchBox1);
    
    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void eigenVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_eigenVectorFunction1ValueChanged
    linearChainOscillator1.setX0(eigenVectorFunction1.getOutputVector());
    springChainView1.setInitialDisplacements(eigenVectorFunction1.getOutputVector());
  }//GEN-LAST:event_eigenVectorFunction1ValueChanged
  
  private void linearChainOscillator1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_linearChainOscillator1SourceChanged
    eigenVectorFunction1.setMatrices(linearChainOscillator1.getC(), linearChainOscillator1.getM());
  }//GEN-LAST:event_linearChainOscillator1SourceChanged
  
  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    eigenVectorFunction1.setIndex(radioButtonBox1.getSelected());
  }//GEN-LAST:event_radioButtonBox1ValueChanged
  
  private void linearChainOscillator1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged
    oscilloscope1.setInputVector(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged
  
  private void linearChainOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged1
    springChainView1.setDisplacements(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged1
  
  private void vectorSliderMPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderMPropertyChange
    linearChainOscillator1.setMasses(vectorSliderM.getValue());
  }//GEN-LAST:event_vectorSliderMPropertyChange
  
  private void vectorSliderCPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderCPropertyChange
    linearChainOscillator1.setSpringStiffnesses(vectorSliderC.getValue());
  }//GEN-LAST:event_vectorSliderCPropertyChange
  
  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    springChainView1.restart();
  }//GEN-LAST:event_timer1Restart2
  
  private void springChainView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springChainView1SourceChanged
    layeredScreen1.addView(springChainView1);
  }//GEN-LAST:event_springChainView1SourceChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    linearChainOscillator1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    linearChainOscillator1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.EigenVectorFunction eigenVectorFunction1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LinearChainOscillator linearChainOscillator1;
  protected physbeans.views.SpringChainView springChainView1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSliderC;
  protected physbeans.inout.VectorSlider vectorSliderM;
// End of variables declaration//GEN-END:variables
  
}
