package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class FourierAnalysis extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new FourierAnalysis(), 580, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    strideVector1 = new physbeans.func.StrideVector();
    squareFunction1 = new physbeans.func.SquareFunction();
    trapezoidFunction1 = new physbeans.func.TrapezoidFunction();
    impulseFunction1 = new physbeans.func.ImpulseFunction();
    phaseCutSineFunction1 = new physbeans.func.PhaseCutSineFunction();
    vectorSwitch2 = new physbeans.func.VectorSwitch();
    functionView1 = new physbeans.views.FunctionView();
    squareFunction2 = new physbeans.func.SquareFunction();
    trapezoidFunction2 = new physbeans.func.TrapezoidFunction();
    impulseFunction2 = new physbeans.func.ImpulseFunction();
    phaseCutSineFunction2 = new physbeans.func.PhaseCutSineFunction();
    objectSwitch1 = new physbeans.func.ObjectSwitch();
    fFTFunction1 = new physbeans.func.FFTFunction();
    vectorSwitch1 = new physbeans.func.VectorSwitch();
    barView1 = new physbeans.views.BarView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel1 = new physbeans.inout.InputPanel();
    radioButtonBox2 = new physbeans.inout.RadioButtonBox();
    textSlider1 = new physbeans.inout.TextSlider();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    
    strideVector1.setMaxVal(3.0);
    strideVector1.setOutputSize(300);
    strideVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        strideVector1ValueChanged(evt);
      }
    });
    
    squareFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        squareFunction1ValueChanged(evt);
      }
    });
    
    trapezoidFunction1.setOffset(-1.0);
    trapezoidFunction1.setScale(2.0);
    trapezoidFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        trapezoidFunction1ValueChanged(evt);
      }
    });
    
    impulseFunction1.setAmplitude(0.3);
    impulseFunction1.setOffset(-1.0);
    impulseFunction1.setPeriod(1.0);
    impulseFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        impulseFunction1ValueChanged(evt);
      }
    });
    
    phaseCutSineFunction1.setPeriod(1.0);
    phaseCutSineFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        phaseCutSineFunction1ValueChanged(evt);
      }
    });
    
    vectorSwitch2.setNInput(4);
    vectorSwitch2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        vectorSwitch2ValueChanged(evt);
      }
    });
    
    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });
    
    trapezoidFunction2.setOffset(-1.0);
    trapezoidFunction2.setScale(2.0);
    impulseFunction2.setAmplitude(0.3);
    impulseFunction2.setOffset(-1.0);
    impulseFunction2.setPeriod(1.0);
    phaseCutSineFunction2.setPeriod(1.0);
    objectSwitch1.setAllObjects(new Object[] {squareFunction2, trapezoidFunction2, impulseFunction2, phaseCutSineFunction2});
    objectSwitch1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        objectSwitch1SourceChanged(evt);
      }
    });
    
    fFTFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        fFTFunction1ValueChanged(evt);
      }
    });
    
    vectorSwitch1.setSelectedInput(2);
    vectorSwitch1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        vectorSwitch1ValueChanged(evt);
      }
    });
    
    barView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        barView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    objectPanel1.setBordered(true);
    objectPanel1.setPreferredSize(new java.awt.Dimension(112, 100));
    layeredScreen1.setMaxX(3.0);
    layeredScreen1.setMaxY(2.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.setMinY(-2.0);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.BorderLayout());
    
    outputPanel1.setBordered(true);
    outputPanel1.setPreferredSize(new java.awt.Dimension(213, 200));
    controlledLayeredScreen1.setMaxX(20.5);
    controlledLayeredScreen1.setMaxY(1.1);
    controlledLayeredScreen1.setMinX(-0.5);
    controlledLayeredScreen1.setMinY(-0.5);
    controlledLayeredScreen1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("osciPosition"));
    controlledLayeredScreen1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("osciScale"));
    outputPanel1.add(controlledLayeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    radioButtonBox2.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s4")
    });
    radioButtonBox2.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s5"));
    radioButtonBox2.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        radioButtonBox2ValueChanged(evt);
        radioButtonBox2ValueChanged1(evt);
      }
    });
    
    inputPanel1.add(radioButtonBox2);
    
    textSlider1.setDescription("p =");
    textSlider1.setModel(new BoundedRealModel(0.0,0.5,1.0));
    textSlider1.setUnit("");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    radioButtonBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s6"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s7"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s8"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s9")
    });
    radioButtonBox1.setSelected(2);
    radioButtonBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.FourierAnalysis", currentLocale).getString("s10"));
    radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        radioButtonBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(radioButtonBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    layeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged

  private void barView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_barView1SourceChanged
    controlledLayeredScreen1.addView(barView1);
  }//GEN-LAST:event_barView1SourceChanged
  
  private void phaseCutSineFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_phaseCutSineFunction1ValueChanged
    vectorSwitch2.setInputVector(3, phaseCutSineFunction1.getOutputVector());
  }//GEN-LAST:event_phaseCutSineFunction1ValueChanged
  
  private void squareFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_squareFunction1ValueChanged
    vectorSwitch2.setInputVector(0, squareFunction1.getOutputVector());
  }//GEN-LAST:event_squareFunction1ValueChanged
  
  private void fFTFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_fFTFunction1ValueChanged
    vectorSwitch1.setAllInputVectors(fFTFunction1.getAllOutputVectors());
  }//GEN-LAST:event_fFTFunction1ValueChanged
  
  private void objectSwitch1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_objectSwitch1SourceChanged
    fFTFunction1.setFunction(
        (PeriodicFunctionWithParameter) objectSwitch1.getActiveObject() );
  }//GEN-LAST:event_objectSwitch1SourceChanged
  
  private void radioButtonBox2ValueChanged1(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox2ValueChanged1
    objectSwitch1.setSelectedInput(radioButtonBox2.getSelected());
  }//GEN-LAST:event_radioButtonBox2ValueChanged1
  
  private void radioButtonBox2ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox2ValueChanged
    vectorSwitch2.setSelectedInput(radioButtonBox2.getSelected());
  }//GEN-LAST:event_radioButtonBox2ValueChanged
  
  private void impulseFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_impulseFunction1ValueChanged
    vectorSwitch2.setInputVector(2, impulseFunction1.getOutputVector());
  }//GEN-LAST:event_impulseFunction1ValueChanged
  
  private void trapezoidFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_trapezoidFunction1ValueChanged
    vectorSwitch2.setInputVector(1, trapezoidFunction1.getOutputVector());
  }//GEN-LAST:event_trapezoidFunction1ValueChanged
  
  private void vectorSwitch2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_vectorSwitch2ValueChanged
    functionView1.setModel(strideVector1.getOutputVector(), vectorSwitch2.getOutputVector());
  }//GEN-LAST:event_vectorSwitch2ValueChanged
  
  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    vectorSwitch1.setSelectedInput(radioButtonBox1.getSelected());
  }//GEN-LAST:event_radioButtonBox1ValueChanged
  
  private void vectorSwitch1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_vectorSwitch1ValueChanged
    barView1.setModel(vectorSwitch1.getOutputVector());
  }//GEN-LAST:event_vectorSwitch1ValueChanged
      
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    fFTFunction1.setParameter(val);
    trapezoidFunction1.setPulseWidth(val);
    impulseFunction1.setPulseWidth(val);
    squareFunction1.setPulseWidth(val);
    phaseCutSineFunction1.setParameter(val);
    strideVector1.trigger();
  }//GEN-LAST:event_textSlider1PropertyChange
    
  private void strideVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_strideVector1ValueChanged
    DVector vec = strideVector1.getOutputVector();
    trapezoidFunction1.setInputVector(vec);
    impulseFunction1.setInputVector(vec);
    squareFunction1.setInputVector(vec);
    phaseCutSineFunction1.setInputVector(vec);
  }//GEN-LAST:event_strideVector1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.BarView barView1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.func.FFTFunction fFTFunction1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.func.ImpulseFunction impulseFunction1;
  protected physbeans.func.ImpulseFunction impulseFunction2;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.func.ObjectSwitch objectSwitch1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.PhaseCutSineFunction phaseCutSineFunction1;
  protected physbeans.func.PhaseCutSineFunction phaseCutSineFunction2;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.inout.RadioButtonBox radioButtonBox2;
  protected physbeans.func.SquareFunction squareFunction1;
  protected physbeans.func.SquareFunction squareFunction2;
  protected physbeans.func.StrideVector strideVector1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.func.TrapezoidFunction trapezoidFunction1;
  protected physbeans.func.TrapezoidFunction trapezoidFunction2;
  protected physbeans.func.VectorSwitch vectorSwitch1;
  protected physbeans.func.VectorSwitch vectorSwitch2;
// End of variables declaration//GEN-END:variables
  
}
