package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 */
public class HarmonicFunction extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new HarmonicFunction(), 590, 360);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    harmonicVectorFunction1 = new physbeans.func.HarmonicFunction();
    harmonicVectorFunction2 = new physbeans.func.HarmonicFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    harmonicVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction1ValueChanged(evt);
      }
    });
    
    harmonicVectorFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction2ValueChanged(evt);
      }
    });
    
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new java.awt.BorderLayout());
    
    jPanel2.setFont(standardFont);
    oscilloscope1.setMaxY(2.2);
    oscilloscope1.setMinY(-2.2);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.HarmonicFunction", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.HarmonicFunction", currentLocale).getString("osciScale"));
    objectPanel1.add(oscilloscope1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(15L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.HarmonicFunction", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("A =");
    textSlider1.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("\u03c9 =");
    textSlider2.setLogarithmic(true);
    textSlider2.setModel(new BoundedRealModel(0.1,0.9999925277988236,5.0));
    textSlider2.setUnit("1/s");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("\u03c6 =");
    textSlider3.setModel(new BoundedRealModel(-3.141592654,0.0,3.141592654));
    textSlider3.setUnit("rad");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    switchBox1.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.HarmonicFunction", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.HarmonicFunction", currentLocale).getString("s2")
    }
    );
    switchBox1.setSelected(new boolean[]{true,false});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.HarmonicFunction", currentLocale).getString("s3"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void harmonicVectorFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction2ValueChanged
    multiplexer1.setInputValues(1, harmonicVectorFunction2.getOutputValue());
  }//GEN-LAST:event_harmonicVectorFunction2ValueChanged
  
  private void harmonicVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction1ValueChanged
    multiplexer1.setInputValues(0, harmonicVectorFunction1.getOutputValue());
  }//GEN-LAST:event_harmonicVectorFunction1ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double phi = textSlider3.getValue();
    harmonicVectorFunction1.setAlpha(phi);
    harmonicVectorFunction2.setAlpha(phi + Math.PI/2.0);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double A  = textSlider1.getValue();
    double omega = textSlider2.getValue();
    harmonicVectorFunction1.setOmega(omega);
    harmonicVectorFunction2.setOmega(omega);
    harmonicVectorFunction2.setAmplitude(A*omega);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double A  = textSlider1.getValue();
    double omega = textSlider2.getValue();
    harmonicVectorFunction1.setAmplitude(A);
    harmonicVectorFunction2.setAmplitude(A*omega);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    double val = timer1.getTime();
    harmonicVectorFunction1.setInputValue(val);
    harmonicVectorFunction2.setInputValue(val);
  }//GEN-LAST:event_timer1NextStep
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.HarmonicFunction harmonicVectorFunction1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction2;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
