package physapps.linearoscillations;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class QuarterCar extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new QuarterCar(), 580, 590);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    linearChainOscillator1 = new physbeans.phys.LinearChainOscillator();
    springChainView1 = new physbeans.views.SpringChainView();
    harmonicBaseExcitation1 = new physbeans.phys.HarmonicBaseExcitation();
    basementForce1 = new physbeans.phys.BasementForce();
    multiplexer1 = new physbeans.func.Multiplexer();
    selectorC = new physbeans.func.Selector();
    selectorB = new physbeans.func.Selector();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSliderM = new physbeans.inout.VectorSlider();
    vectorSliderC = new physbeans.inout.VectorSlider();
    vectorSliderB = new physbeans.inout.VectorSlider();
    textSliderU = new physbeans.inout.TextSlider();
    textSliderOm = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    linearChainOscillator1.setAbsoluteTolerance(1.0E-8);
    linearChainOscillator1.setDamperCoefficients(DVector.valueOf("[0.0,0.0,0.0]"));
    linearChainOscillator1.setExternalForceFunction(harmonicBaseExcitation1);
    linearChainOscillator1.setMasses(DVector.valueOf("[0.0,0.0]"));
    linearChainOscillator1.setSpringStiffnesses(DVector.valueOf("[0.0,0.0,0.0]"));
    linearChainOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        linearChainOscillator1ValueChanged1(evt);
        linearChainOscillator1ValueChanged2(evt);
        linearChainOscillator1ValueChanged(evt);
      }
    });

    springChainView1.setFScale(1.3E-5);
    springChainView1.setXScale(0.15);
    springChainView1.setBasementWidth(0.5);
    springChainView1.setHideHugeSprings(true);
    springChainView1.setInitialBase(0.2);
    springChainView1.setInitialDisplacements(DVector.valueOf("[0.0,0.0]"));
    springChainView1.setMassScale(0.2);
    springChainView1.setShowArrows(true);
    springChainView1.setSpringScale(30.0);
    springChainView1.setSystem(linearChainOscillator1);
    springChainView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springChainView1SourceChanged(evt);
      }
    });

    harmonicBaseExcitation1.setSystem(linearChainOscillator1);
    harmonicBaseExcitation1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicBaseExcitation1ValueChanged(evt);
        harmonicBaseExcitation1ValueChanged1(evt);
      }
    });

    basementForce1.setExciter(harmonicBaseExcitation1);
    basementForce1.setInputLength(4);
    basementForce1.setSystem(linearChainOscillator1);
    basementForce1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        basementForce1ValueChanged(evt);
      }
    });

    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });

    selectorC.setIndex(new int[]{0,1});
    selectorC.setOutputLength(3);
    selectorC.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorCValueChanged(evt);
      }
    });

    selectorB.setIndex(new int[]{0,1});
    selectorB.setOutputLength(3);
    selectorB.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorBValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(2.0);
    layeredScreen1.setMinX(-2.0);
    layeredScreen1.setMinY(-0.2);
    layeredScreen1.setOpaque(true);
    layeredScreen1.setXyExchanged(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(300, 142));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[]{true,true,true});
    oscilloscope1.setMaxY(40.0);
    oscilloscope1.setMinY(-40.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.linearoscillations.QuarterCar", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    oscilloscope1.setTimePerTick(0.002);
    outputPanel.add(oscilloscope1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(20L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(0.002);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });
    inputPanel.add(timer1);

    vectorSliderM.setCount(2);
    vectorSliderM.setDescription("m =");
    vectorSliderM.setInitialValues(DVector.valueOf("[30.0,500.0]"));
    vectorSliderM.setLogarithmic(true);
    vectorSliderM.setMaximum(1000.0);
    vectorSliderM.setMinimum(10.0);
    vectorSliderM.setUnit("kg");
    vectorSliderM.setVertical(false);
    vectorSliderM.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderMPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderM);

    vectorSliderC.setCount(2);
    vectorSliderC.setDescription("c =");
    vectorSliderC.setInitialValues(DVector.valueOf("[100000.0,30000.0]"));
    vectorSliderC.setLogarithmic(true);
    vectorSliderC.setMaximum(1000000.0);
    vectorSliderC.setMinimum(10000.0);
    vectorSliderC.setUnit("N/m");
    vectorSliderC.setVertical(false);
    vectorSliderC.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderCPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderC);

    vectorSliderB.setCount(2);
    vectorSliderB.setDescription("b =");
    vectorSliderB.setInitialValues(DVector.valueOf("[3000.0,5.0]"));
    vectorSliderB.setLogarithmic(true);
    vectorSliderB.setMaximum(10000.0);
    vectorSliderB.setUnit("Ns/m");
    vectorSliderB.setVertical(false);
    vectorSliderB.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderBPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderB);

    textSliderU.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
    textSliderU.setDescription("=");
    textSliderU.setDescriptionIcon("physbeans/resources/uhat.gif"); // NOI18N
    textSliderU.setLogarithmic(true);
    textSliderU.setModel(new BoundedRealModel(1.0,10.0,100.0));
    textSliderU.setUnit("cm");
    textSliderU.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderUPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderU);

    textSliderOm.setDescription("\u03a9 =");
    textSliderOm.setLogarithmic(true);
    textSliderOm.setModel(new BoundedRealModel(10.0,100.0,1000.0));
    textSliderOm.setUnit("1/s");
    textSliderOm.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderOmPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderOm);

    switchBox1.setBoxLabel(new String[] {"u [cm]", "a2 [m/s\u00b2]", "R [kN]"});
    switchBox1.setSelected(new boolean[]{true,true,true});
    switchBox1.setTitle(bundle.getString("s1")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel.add(switchBox1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void selectorBValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorBValueChanged
    linearChainOscillator1.setDamperCoefficients(selectorB.getOutputVector());
  }//GEN-LAST:event_selectorBValueChanged

  private void vectorSliderBPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderBPropertyChange
    selectorB.setInputVector(vectorSliderB.getValue());
  }//GEN-LAST:event_vectorSliderBPropertyChange

  private void selectorCValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorCValueChanged
    linearChainOscillator1.setSpringStiffnesses(selectorC.getOutputVector());
  }//GEN-LAST:event_selectorCValueChanged

  private void vectorSliderCPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderCPropertyChange
    selectorC.setInputVector(vectorSliderC.getValue());
  }//GEN-LAST:event_vectorSliderCPropertyChange

  private void textSliderUPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderUPropertyChange
    double u = 0.01*textSliderU.getValue();
    harmonicBaseExcitation1.setAmplitude(u);
    springChainView1.setInitialBase(u);
}//GEN-LAST:event_textSliderUPropertyChange
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
    
  private void linearChainOscillator1ValueChanged2(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged2
    DVector a = linearChainOscillator1.getAccelerations();
    multiplexer1.setInputValues(1, a.get(1));
  }//GEN-LAST:event_linearChainOscillator1ValueChanged2
  
  private void linearChainOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged1
    springChainView1.setDisplacements(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged1
    
  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    harmonicBaseExcitation1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep1
    
  private void textSliderOmPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderOmPropertyChange
    harmonicBaseExcitation1.setOmega(textSliderOm.getValue());
  }//GEN-LAST:event_textSliderOmPropertyChange
        
  private void vectorSliderMPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderMPropertyChange
    linearChainOscillator1.setMasses(vectorSliderM.getValue());
  }//GEN-LAST:event_vectorSliderMPropertyChange
    
  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    springChainView1.restart();
  }//GEN-LAST:event_timer1Restart2
  
  private void springChainView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springChainView1SourceChanged
    layeredScreen1.addView(springChainView1);
  }//GEN-LAST:event_springChainView1SourceChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    linearChainOscillator1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    linearChainOscillator1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void linearChainOscillator1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged
    basementForce1.setInputVector(linearChainOscillator1.getOutputVector());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged

  private void basementForce1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_basementForce1ValueChanged
    multiplexer1.singleInputValue(2, 1e-3*basementForce1.getOutputValue());
  }//GEN-LAST:event_basementForce1ValueChanged

  private void harmonicBaseExcitation1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicBaseExcitation1ValueChanged
    double u = harmonicBaseExcitation1.getBasementExcitation();
    multiplexer1.singleInputValue(0, 100*u);
    springChainView1.setBase(u);
  }//GEN-LAST:event_harmonicBaseExcitation1ValueChanged

  private void harmonicBaseExcitation1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicBaseExcitation1ValueChanged1
    springChainView1.setForces(harmonicBaseExcitation1.getOutputVector());
  }//GEN-LAST:event_harmonicBaseExcitation1ValueChanged1
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.BasementForce basementForce1;
  protected physbeans.phys.HarmonicBaseExcitation harmonicBaseExcitation1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LinearChainOscillator linearChainOscillator1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.Selector selectorB;
  protected physbeans.func.Selector selectorC;
  protected physbeans.views.SpringChainView springChainView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSliderOm;
  protected physbeans.inout.TextSlider textSliderU;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSliderB;
  protected physbeans.inout.VectorSlider vectorSliderC;
  protected physbeans.inout.VectorSlider vectorSliderM;
  // End of variables declaration//GEN-END:variables
  
}
