package physapps.mathematics;

import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class HermitePolynomials extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new HermitePolynomials(), 540, 440);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hermitePolynomial1 = new physbeans.func.HermitePolynomial();
    strideVector1 = new physbeans.func.StrideVector();
    functionView1 = new physbeans.views.FunctionView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel = new physbeans.inout.PhysicsPanel();
    integerTextSlider1 = new physbeans.inout.IntegerTextSlider();
    objectPanel = new physbeans.inout.PhysicsPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    message1 = new physbeans.inout.Message();

    hermitePolynomial1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        hermitePolynomial1ValueChanged(evt);
      }
    });

    strideVector1.setMaxVal(3.5);
    strideVector1.setMinVal(-3.5);
    strideVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        strideVector1ValueChanged(evt);
      }
    });

    functionView1.setLineColor(new java.awt.Color(50, 91, 221));
    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(1);
    simpleFigureView1.setP1(DVector.valueOf("[-3.5,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[3.5,0.0]"));
    simpleFigureView1.setP3(DVector.valueOf("[0.0,10000.0]"));
    simpleFigureView1.setP4(DVector.valueOf("[0.0,-10000.0]"));

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setOpaque(true);
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.LINE_AXIS));

    integerTextSlider1.setColumns(10);
    integerTextSlider1.setDescription("n =");
    integerTextSlider1.setModel(new BoundedRealModel(0.0,4.0,9.0));
    integerTextSlider1.setUnit("");
    integerTextSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        integerTextSlider1PropertyChange(evt);
        integerTextSlider1PropertyChange1(evt);
      }
    });
    inputPanel.add(integerTextSlider1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.NORTH);

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setOpaque(true);
    objectPanel.setPreferredSize(new java.awt.Dimension(100, 250));
    objectPanel.setLayout(new java.awt.BorderLayout());

    controlledLayeredScreen1.setInitialScaleIndex(6);
    controlledLayeredScreen1.setMaxX(3.5);
    controlledLayeredScreen1.setMaxY(100.0);
    controlledLayeredScreen1.setMinX(-3.5);
    controlledLayeredScreen1.setMinY(-100.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mathematics.HermitePolynomials", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    controlledLayeredScreen1.setViewActive(new boolean[] {true, true});
    objectPanel.add(controlledLayeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel1.add(objectPanel, java.awt.BorderLayout.CENTER);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBordered(true);
    outputPanel.setOpaque(true);

    message1.setColumns(35);
    message1.setDescription("Hn(x) =");
    message1.setRows(1);
    message1.setSeparation(5);
    outputPanel.add(message1);

    jPanel1.add(outputPanel, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void integerTextSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange
    try {
      hermitePolynomial1.setOrder(integerTextSlider1.getValueAsInt());
      strideVector1.trigger();
    } catch (java.lang.IllegalArgumentException e1) {
      e1.printStackTrace();
    }
  }//GEN-LAST:event_integerTextSlider1PropertyChange

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
    controlledLayeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_functionView1SourceChanged

  private void strideVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_strideVector1ValueChanged
    hermitePolynomial1.setInputVector(strideVector1.getOutputVector());
  }//GEN-LAST:event_strideVector1ValueChanged

  private void hermitePolynomial1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_hermitePolynomial1ValueChanged
    functionView1.setModel(strideVector1.getOutputVector(), hermitePolynomial1.getOutputVector());
  }//GEN-LAST:event_hermitePolynomial1ValueChanged

  private void integerTextSlider1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange1
    message1.setMessage(hermitePolynomial1.toString());
  }//GEN-LAST:event_integerTextSlider1PropertyChange1

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.func.HermitePolynomial hermitePolynomial1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected physbeans.inout.IntegerTextSlider integerTextSlider1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.Message message1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.func.StrideVector strideVector1;
  // End of variables declaration//GEN-END:variables
}
