package physapps.mechanics;

import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class CircularAcceleration extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new CircularAcceleration(), 580, 580);
  }

  /**
   * Creates new form Simulation
   */
  public void init() {
    setLocale();
    initComponents();
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    parsedFunctionPhiOm = new physbeans.func.ParsedFunction();
    parsedFunction1 = new physbeans.func.ParsedFunction();
    selectorOsci = new physbeans.func.Selector();
    selectorXYScope = new physbeans.func.Selector();
    selectorVecV = new physbeans.func.Selector();
    vectorDecompositionViewV = new physbeans.views.VectorDecompositionView();
    selectorVecA = new physbeans.func.Selector();
    vectorDecompositionViewA = new physbeans.views.VectorDecompositionView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    xYScope1 = new physbeans.inout.XYScope();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderR = new physbeans.inout.TextSlider();
    textSliderOm = new physbeans.inout.TextSlider();
    textSliderAl = new physbeans.inout.TextSlider();
    switchBoxDisplay = new physbeans.inout.SwitchBox();
    switchBoxOsci = new physbeans.inout.SwitchBox();

    parsedFunctionPhiOm.setFunction(new String[] {"0.5*al*t*t + om0*t", "al*t + om0"});
    parsedFunctionPhiOm.setParameter(DVector.valueOf("[0.0,1.0]"));
    parsedFunctionPhiOm.setVariableName(new String[] {"t", "om0", "al"});
    parsedFunctionPhiOm.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunctionPhiOmValueChanged(evt);
      }
    });

    parsedFunction1.setFunction(new String[] {"phi", "om", "r*cos(phi)", "r*sin(phi)", "r*om", "r*sqrt(al*al + om^4)", "-r*om*om", "r*al", "-r*om*sin(phi)", "r*om*cos(phi)", "-r*al*sin(phi) - r*om*om*cos(phi)", "r*al*cos(phi) - r*om*om*sin(phi)"});
    parsedFunction1.setParameter(DVector.valueOf("[1.0,1.0]"));
    parsedFunction1.setVariableName(new String[] {"phi", "om", "r", "al"});
    parsedFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunction1ValueChanged(evt);
      }
    });

    selectorOsci.setIndex(new int[] {0, 1, 2, 3, 4, 5, 6, 7});
    selectorOsci.setInputLength(12);
    selectorOsci.setOutputLength(8);
    selectorOsci.setOutputVector(DVector.valueOf("[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]"));
    selectorOsci.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorOsciValueChanged(evt);
      }
    });

    selectorXYScope.setIndex(new int[] {2, 3});
    selectorXYScope.setInputLength(12);
    selectorXYScope.setOutputLength(2);
    selectorXYScope.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorXYScopeValueChanged(evt);
      }
    });

    selectorVecV.setIndex(new int[] {2, 3, 8, 9});
    selectorVecV.setInputLength(12);
    selectorVecV.setOutputLength(4);
    selectorVecV.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorVecVValueChanged(evt);
      }
    });

    vectorDecompositionViewV.setArrowScale(0.25);
    vectorDecompositionViewV.setDepth(45);
    vectorDecompositionViewV.setInitialValues(DVector.valueOf("[1.0,0.0,0.0,0.0]"));
    vectorDecompositionViewV.setMarkerSize(10);
    vectorDecompositionViewV.setPolar(true);
    vectorDecompositionViewV.setShowMarker(true);
    vectorDecompositionViewV.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        vectorDecompositionViewVSourceChanged(evt);
      }
    });

    selectorVecA.setIndex(new int[] {2, 3, 10, 11});
    selectorVecA.setInputLength(12);
    selectorVecA.setOutputLength(4);
    selectorVecA.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorVecAValueChanged(evt);
      }
    });

    vectorDecompositionViewA.setArrowColor(new java.awt.Color(0, 0, 255));
    vectorDecompositionViewA.setArrowScale(0.25);
    vectorDecompositionViewA.setDepth(40);
    vectorDecompositionViewA.setInitialValues(DVector.valueOf("[1.0,0.0,1.0,0.0]"));
    vectorDecompositionViewA.setMarkerSize(10);
    vectorDecompositionViewA.setPolar(true);
    vectorDecompositionViewA.setShowMarker(true);
    vectorDecompositionViewA.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        vectorDecompositionViewASourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new java.awt.BorderLayout());

    xYScope1.setBufferSize(10240);
    xYScope1.setDotSize(5);
    xYScope1.setEqualScales(true);
    xYScope1.setLineColor(new Color[]{
      new Color(0, 0, 0),
      new Color(255, 0, 255),
      new Color(0, 255, 255),
      new Color(255, 175, 175),
      new Color(255, 200, 0),
      new Color(255, 0, 0),
      new Color(0, 0, 255),
      new Color(255, 255, 0)});
  xYScope1.setMaxX(2.5);
  xYScope1.setMinX(-2.5);
  java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mechanics.CircularAcceleration", currentLocale); // NOI18N
  xYScope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
  xYScope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
  xYScope1.setScaleX(true);
  xYScope1.setScreenBackground(new java.awt.Color(255, 255, 255));
  xYScope1.setShowMarker(true);
  objectPanel.add(xYScope1, java.awt.BorderLayout.CENTER);

  jPanel2.add(objectPanel);

  outputPanel.setBackground(new java.awt.Color(150, 200, 255));
  outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
  outputPanel.setFont(standardFont);
  outputPanel.setOpaque(true);
  outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

  oscilloscope1.setNLines(8);
  oscilloscope1.setLineActive(new boolean[] {true, true, false, false, false, false, false, false});
  oscilloscope1.setMaxY(12.0);
  oscilloscope1.setMinY(-12.0);
  oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
  oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
  oscilloscope1.setTimePerTick(0.02);
  outputPanel.add(oscilloscope1);

  jPanel2.add(outputPanel);

  jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

  inputPanel.setBackground(new java.awt.Color(100, 255, 255));
  inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
  inputPanel.setFont(standardFont);
  inputPanel.setOpaque(true);
  inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
  inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

  timer1.setDelay(30L);
  timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
  timer1.setTimeIncrement(0.02);
  timer1.addTimerListener(new physbeans.event.TimerListener() {
    public void nextStep(physbeans.event.NextStepEvent evt) {
      timer1NextStep(evt);
    }
    public void restart(physbeans.event.RestartEvent evt) {
      timer1Restart(evt);
    }
  });
  inputPanel.add(timer1);

  textSliderR.setDescription("r =");
  textSliderR.setModel(new BoundedRealModel(0.0,1.0,2.0));
  textSliderR.setUnit("m");
  textSliderR.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderRPropertyChange(evt);
    }
  });
  inputPanel.add(textSliderR);

  textSliderOm.setDescription("\u03c9\u2080 =");
  textSliderOm.setModel(new BoundedRealModel(-3.0,0.0,3.0));
  textSliderOm.setUnit("1/s");
  textSliderOm.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderOmPropertyChange(evt);
    }
  });
  inputPanel.add(textSliderOm);

  textSliderAl.setDescription("\u03b1 =");
  textSliderAl.setModel(new BoundedRealModel(-2.0,0.5,2.0));
  textSliderAl.setUnit("1/s²");
  textSliderAl.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderAlPropertyChange(evt);
    }
  });
  inputPanel.add(textSliderAl);

  switchBoxDisplay.setBoxLabel(new String[] {
    bundle.getString("s3"),
    bundle.getString("s4"),
    bundle.getString("s5")
  });
  switchBoxDisplay.setSelected(new boolean[] {true, true, true});
  switchBoxDisplay.setTitle(bundle.getString("s2")); // NOI18N
  switchBoxDisplay.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBoxDisplayValueChanged(evt);
    }
  });
  inputPanel.add(switchBoxDisplay);

  switchBoxOsci.setBoxLabel(new String[] {"\u03c6", "\u03c9", "x", "y", "v", "a", "ar", "at"});
  switchBoxOsci.setSelected(new boolean[]{true,true,false,false,false,false,false,false});
  switchBoxOsci.setTitle(bundle.getString("s1")); // NOI18N
  switchBoxOsci.setWithTwoColumns(true);
  switchBoxOsci.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBoxOsciValueChanged(evt);
    }
  });
  inputPanel.add(switchBoxOsci);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    parsedFunctionPhiOm.singleInputValue(0, timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void textSliderOmPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderOmPropertyChange
    double r = textSliderR.getValue();
    double om = textSliderOm.getValue();
    parsedFunctionPhiOm.setParameter(0, om);
    vectorDecompositionViewV.setInitialValue(3, r * om);
    vectorDecompositionViewA.setInitialValue(2, -r * om * om);
  }//GEN-LAST:event_textSliderOmPropertyChange

  private void textSliderAlPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderAlPropertyChange
    double r = textSliderR.getValue();
    double al = textSliderAl.getValue();
    parsedFunctionPhiOm.setParameter(1, al);
    parsedFunction1.setParameter(1, al);
    vectorDecompositionViewA.setInitialValue(3, r * al);
  }//GEN-LAST:event_textSliderAlPropertyChange

  private void textSliderRPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderRPropertyChange
    double r = textSliderR.getValue();
    double om = textSliderOm.getValue();
    double al = textSliderAl.getValue();
    parsedFunction1.setParameter(0, r);
    vectorDecompositionViewV.setInitialValue(0, r);
    vectorDecompositionViewV.setInitialValue(3, r * om);
    vectorDecompositionViewA.setInitialValue(0, r);
    vectorDecompositionViewA.setInitialValue(2, -r * om * om);
    vectorDecompositionViewA.setInitialValue(3, r * al);
  }//GEN-LAST:event_textSliderRPropertyChange

  private void parsedFunctionPhiOmValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunctionPhiOmValueChanged
    parsedFunction1.setInputVector(parsedFunctionPhiOm.getOutputVector());
  }//GEN-LAST:event_parsedFunctionPhiOmValueChanged

  private void parsedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunction1ValueChanged
    DVector vec = parsedFunction1.getOutputVector();
    selectorOsci.setInputVector(vec);
    selectorXYScope.setInputVector(vec);
    selectorVecV.setInputVector(vec);
    selectorVecA.setInputVector(vec);
  }//GEN-LAST:event_parsedFunction1ValueChanged

  private void selectorOsciValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorOsciValueChanged
    oscilloscope1.setInputVector(selectorOsci.getOutputVector());
  }//GEN-LAST:event_selectorOsciValueChanged

  private void switchBoxOsciValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBoxOsciValueChanged
    oscilloscope1.setLineActive(switchBoxOsci.getSelected());
  }//GEN-LAST:event_switchBoxOsciValueChanged

  private void selectorXYScopeValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorXYScopeValueChanged
    xYScope1.setInputVector(selectorXYScope.getOutputVector());
  }//GEN-LAST:event_selectorXYScopeValueChanged

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    xYScope1.restart();
    oscilloscope1.restart();
    vectorDecompositionViewV.restart();
    vectorDecompositionViewA.restart();
  }//GEN-LAST:event_timer1Restart

  private void selectorVecVValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorVecVValueChanged
    vectorDecompositionViewV.setModel(selectorVecV.getOutputVector());
  }//GEN-LAST:event_selectorVecVValueChanged

  private void vectorDecompositionViewVSourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_vectorDecompositionViewVSourceChanged
    xYScope1.addView(vectorDecompositionViewV);
  }//GEN-LAST:event_vectorDecompositionViewVSourceChanged

  private void selectorVecAValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorVecAValueChanged
    vectorDecompositionViewA.setModel(selectorVecA.getOutputVector());
  }//GEN-LAST:event_selectorVecAValueChanged

  private void vectorDecompositionViewASourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_vectorDecompositionViewASourceChanged
    xYScope1.addView(vectorDecompositionViewA);
  }//GEN-LAST:event_vectorDecompositionViewASourceChanged

  private void switchBoxDisplayValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBoxDisplayValueChanged
    xYScope1.setViewActive(switchBoxDisplay.getSelected());
  }//GEN-LAST:event_switchBoxDisplayValueChanged

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.ParsedFunction parsedFunction1;
  protected physbeans.func.ParsedFunction parsedFunctionPhiOm;
  protected physbeans.func.Selector selectorOsci;
  protected physbeans.func.Selector selectorVecA;
  protected physbeans.func.Selector selectorVecV;
  protected physbeans.func.Selector selectorXYScope;
  protected physbeans.inout.SwitchBox switchBoxDisplay;
  protected physbeans.inout.SwitchBox switchBoxOsci;
  protected physbeans.inout.TextSlider textSliderAl;
  protected physbeans.inout.TextSlider textSliderOm;
  protected physbeans.inout.TextSlider textSliderR;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.VectorDecompositionView vectorDecompositionViewA;
  protected physbeans.views.VectorDecompositionView vectorDecompositionViewV;
  protected physbeans.inout.XYScope xYScope1;
  // End of variables declaration//GEN-END:variables

}
