package physapps.nonlinear;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class PhaseDrivenPendulum extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new PhaseDrivenPendulum(), 535, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    mathPendulum1 = new physbeans.phys.MathPendulum();
    harmonicVectorFunction1 = new physbeans.func.HarmonicFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    pendulumView1 = new physbeans.views.PendulumView();
    reducePhaseFunction1 = new physbeans.func.ReducePhaseFunction();
    mergeFunction1 = new physbeans.func.MergeFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    xYScope1 = new physbeans.inout.XYScope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    mathPendulum1.setExternalTorqueFunction(harmonicVectorFunction1);
    mathPendulum1.setG(1.0);
    mathPendulum1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mathPendulum1ValueChanged1(evt);
        mathPendulum1ValueChanged(evt);
      }
    });

    harmonicVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction1ValueChanged(evt);
      }
    });

    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });

    pendulumView1.setArrowScale(0.2);
    pendulumView1.setInitialValues(DVector.valueOf("[0.0,1.0]"));
    pendulumView1.setShowArrow(true);
    pendulumView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pendulumView1SourceChanged(evt);
      }
    });

    reducePhaseFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        reducePhaseFunction1ValueChanged(evt);
      }
    });

    mergeFunction1.setUseFirstVector(new boolean[]{false,false});
    mergeFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mergeFunction1ValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setBordered(true);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    xYScope1.setBufferSize(20000);
    xYScope1.setDotted(true);
    xYScope1.setMaxX(3.2);
    xYScope1.setMaxY(3.2);
    xYScope1.setMinX(-3.2);
    xYScope1.setMinY(-3.2);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.nonlinear.PhaseDrivenPendulum", currentLocale); // NOI18N
    xYScope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    xYScope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    xYScope1.setScaleX(true);
    outputPanel1.add(xYScope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(15L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("\u03c6(0) =");
    textSlider1.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider1.setUnit("* \u03c0");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("d\u03c6/dt(0) =");
    textSlider2.setModel(new BoundedRealModel(-3.0,0.0,3.0));
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("\u03bb =");
    textSlider3.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    textSlider4.setDescription("A =");
    textSlider4.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider5.setDescription("\u03c9_ext =");
    textSlider5.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider5.setUnit("");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider5);

    switchBox1.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.nonlinear.PhaseDrivenPendulum", currentLocale).getString("s1")
    }
  );
  switchBox1.setSelected(new boolean[]{false});
  switchBox1.setTitle("");
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel1.add(switchBox1);

  jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void mergeFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mergeFunction1ValueChanged
    xYScope1.setInputVector(mergeFunction1.getOutputVector());
  }//GEN-LAST:event_mergeFunction1ValueChanged

  private void reducePhaseFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_reducePhaseFunction1ValueChanged
    mergeFunction1.setFirstVector(reducePhaseFunction1.getOutputVector());
  }//GEN-LAST:event_reducePhaseFunction1ValueChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    pendulumView1.setModel(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void harmonicVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction1ValueChanged
    multiplexer1.singleInputValue(1, harmonicVectorFunction1.getOutputValue());
  }//GEN-LAST:event_harmonicVectorFunction1ValueChanged
  
  private void mathPendulum1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mathPendulum1ValueChanged
    multiplexer1.singleInputValue(0, mathPendulum1.getAngle());
  }//GEN-LAST:event_mathPendulum1ValueChanged
  
  private void pendulumView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pendulumView1SourceChanged
    layeredScreen1.addView(pendulumView1);
  }//GEN-LAST:event_pendulumView1SourceChanged
    
  private void mathPendulum1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mathPendulum1ValueChanged1
    reducePhaseFunction1.setInputVector(mathPendulum1.getOutputVector());
    mergeFunction1.setSecondVector(mathPendulum1.getOutputVector());
  }//GEN-LAST:event_mathPendulum1ValueChanged1
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    mergeFunction1.setUseFirstVector(0, switchBox1.getFirstSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    harmonicVectorFunction1.setOmega(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    harmonicVectorFunction1.setAmplitude(val);
    pendulumView1.setInitialValue(1, val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    mathPendulum1.setB(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    mathPendulum1.setOmega0(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue()*Math.PI;
    mathPendulum1.setPhi0(val);
    pendulumView1.setInitialValue(0, val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    mathPendulum1.restart();
    pendulumView1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    harmonicVectorFunction1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep1
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    mathPendulum1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.HarmonicFunction harmonicVectorFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.MathPendulum mathPendulum1;
  protected physbeans.func.MergeFunction mergeFunction1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.views.PendulumView pendulumView1;
  protected physbeans.func.ReducePhaseFunction reducePhaseFunction1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
  // End of variables declaration//GEN-END:variables
  
}
