package physapps.nuclearphysics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for wide simulation applets<br>
 * contains an input, object and output panel<br>
 * expects classes SpecialText and ResourceBundles for all texts
 */
public class RadioactiveDecay extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new RadioactiveDecay(), 550, 570);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    radioactiveDecayChain1 = new physbeans.phys.RadioactiveDecayChain();
    particleDecayChain1 = new physbeans.phys.ParticleDecayChain();
    particleStateView1 = new physbeans.views.ParticleStateView();
    multiplexer1 = new physbeans.func.Multiplexer();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    integerTextSlider1 = new physbeans.inout.IntegerTextSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    
    radioactiveDecayChain1.setTHalf(DVector.valueOf("[8.0,Infinity]"));
    radioactiveDecayChain1.setInitialValues(DVector.valueOf("[100.0,0.0]"));
    radioactiveDecayChain1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        radioactiveDecayChain1ValueChanged(evt);
      }
    });
    
    particleDecayChain1.setTHalf2(Double.POSITIVE_INFINITY);
    particleDecayChain1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        particleDecayChain1ValueChanged(evt);
      }
    });
    
    particleStateView1.setMinimalNumberOfColumns(7);
    particleStateView1.setParticleColor(1, Color.black);
    particleStateView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        particleStateView1SourceChanged(evt);
      }
    });
    
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new java.awt.BorderLayout());
    
    jPanel2.setFont(standardFont);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(25L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    integerTextSlider1.setDescription("N(0) =");
    integerTextSlider1.setLogarithmic(true);
    integerTextSlider1.setModel(new BoundedRealModel(1.0,100.0,1000.0));
    integerTextSlider1.setUnit("");
    integerTextSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        integerTextSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(integerTextSlider1);
    
    textSlider1.setDescription("T\u00bd =");
    textSlider1.setLogarithmic(true);
    textSlider1.setModel(new BoundedRealModel(1.0,8.0,50.0));
    textSlider1.setUnit("s");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    switchBox1.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay", currentLocale).getString("s2")
    });
    switchBox1.setSelected(new boolean[]{true,true});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay", currentLocale).getString("s3"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel2.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);
    
    oscilloscope1.setLineActive(new boolean[]{true,true});
    oscilloscope1.setMaxY(100.0);
    oscilloscope1.setMinY(0.0);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay", currentLocale).getString("osciScale"));
    outputPanel1.add(oscilloscope1);
    
    jPanel1.add(outputPanel1, java.awt.BorderLayout.CENTER);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
    
  private void particleStateView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_particleStateView1SourceChanged
    layeredScreen1.addView(particleStateView1);
  }//GEN-LAST:event_particleStateView1SourceChanged
  
  private void radioactiveDecayChain1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_radioactiveDecayChain1ValueChanged
    multiplexer1.setInputValues(0, radioactiveDecayChain1.getOutputValue());
  }//GEN-LAST:event_radioactiveDecayChain1ValueChanged
  
  private void particleDecayChain1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_particleDecayChain1ValueChanged
    multiplexer1.setInputValues(1, particleDecayChain1.getOutputValues(0));
    particleStateView1.setModel(particleDecayChain1.getStates());
  }//GEN-LAST:event_particleDecayChain1ValueChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    radioactiveDecayChain1.setTHalf(0, val);
    particleDecayChain1.setTHalf1(val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void integerTextSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange
    radioactiveDecayChain1.setInitialValue(0, integerTextSlider1.getValue());
    particleDecayChain1.setN0(integerTextSlider1.getValueAsInt());
  }//GEN-LAST:event_integerTextSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
    particleDecayChain1.restart();
    radioactiveDecayChain1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    particleDecayChain1.setTime(timer1.getTime());
    radioactiveDecayChain1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected physbeans.inout.IntegerTextSlider integerTextSlider1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.ParticleDecayChain particleDecayChain1;
  protected physbeans.views.ParticleStateView particleStateView1;
  protected physbeans.phys.RadioactiveDecayChain radioactiveDecayChain1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
