package physapps.thermodynamics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.phys.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class UniversalTSCycle extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new UniversalTSCycle(), 560, 470);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    cyclicProcess1 = new physbeans.phys.CyclicProcess();
    perfectGas1 = new physbeans.phys.PerfectGas();
    multiplexer2 = new physbeans.func.Multiplexer();
    multiplexer3 = new physbeans.func.Multiplexer();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    xYScope1 = new physbeans.inout.XYScope();
    outputPanel1 = new physbeans.inout.OutputPanel();
    xYScope2 = new physbeans.inout.XYScope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSliderN = new physbeans.inout.VectorSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    vectorSliderV = new physbeans.inout.VectorSlider();
    
    cyclicProcess1.setNSteps(new int[]{50,50,50,50});
    cyclicProcess1.setPoints(DVector.valueOf("[1.435,2.87,9.055]"));
    cyclicProcess1.setPolytropicExponents(DVector.valueOf("[1.0,1.4,1.0,1.4]"));
    cyclicProcess1.setStartPressure(2000000.0);
    cyclicProcess1.setSystem(perfectGas1);
    perfectGas1.setMass(10.0);
    perfectGas1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        perfectGas1SourceChanged(evt);
        perfectGas1SourceChanged1(evt);
      }
    });
    
    multiplexer2.setAutoTriggered(false);
    multiplexer2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer2ValueChanged(evt);
      }
    });
    
    multiplexer3.setAutoTriggered(false);
    multiplexer3.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer3ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    xYScope1.setBufferSize(5000);
    xYScope1.setDotSize(6);
    xYScope1.setMaxX(11.0);
    xYScope1.setMaxY(2600000.0);
    xYScope1.setMinX(0.0);
    xYScope1.setMinY(0.0);
    xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.UniversalTSCycle", currentLocale).getString("osciPosition"));
    xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.UniversalTSCycle", currentLocale).getString("osciScale"));
    xYScope1.setShowMarker(true);
    objectPanel1.add(xYScope1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    xYScope2.setBufferSize(5000);
    xYScope2.setDotSize(6);
    xYScope2.setMaxX(10000.0);
    xYScope2.setMaxY(2000.0);
    xYScope2.setMinX(0.0);
    xYScope2.setMinY(0.0);
    xYScope2.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.UniversalTSCycle", currentLocale).getString("osciPosition"));
    xYScope2.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.UniversalTSCycle", currentLocale).getString("osciScale"));
    xYScope2.setScaleX(true);
    xYScope2.setShowMarker(true);
    outputPanel1.add(xYScope2);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(20L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.thermodynamics.UniversalTSCycle", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    vectorSliderN.setDescription("ni =");
    vectorSliderN.setInitialValues(DVector.valueOf("[100.0,1.4,100.0,1.4]"));
    vectorSliderN.setLogarithmic(true);
    vectorSliderN.setMaximum(100.0);
    vectorSliderN.setMinimum(0.01);
    vectorSliderN.setUnit("");
    vectorSliderN.setVertical(false);
    vectorSliderN.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderNPropertyChange(evt);
      }
    });
    
    inputPanel1.add(vectorSliderN);
    
    textSlider1.setDescription("p1 =");
    textSlider1.setModel(new BoundedRealModel(300000.0,1000000.0,2500000.0));
    textSlider1.setUnit("Pa");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    vectorSliderV.setCount(3);
    vectorSliderV.setDescription("Vi =");
    vectorSliderV.setInitialValues(DVector.valueOf("[1.714,1.7,10.0]"));
    vectorSliderV.setMaximum(10.0);
    vectorSliderV.setMinimum(0.1);
    vectorSliderV.setUnit("m\u00b3");
    vectorSliderV.setVertical(false);
    vectorSliderV.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderVPropertyChange(evt);
      }
    });
    
    inputPanel1.add(vectorSliderV);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void vectorSliderNPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderNPropertyChange
    cyclicProcess1.setPolytropicExponents(vectorSliderN.getValue());
  }//GEN-LAST:event_vectorSliderNPropertyChange

  private void vectorSliderVPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderVPropertyChange
    cyclicProcess1.setPoints(vectorSliderV.getValue());
  }//GEN-LAST:event_vectorSliderVPropertyChange
  
  private void multiplexer3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer3ValueChanged
     xYScope2.setInputVector(multiplexer3.getOutputVector());
  }//GEN-LAST:event_multiplexer3ValueChanged
    
  private void perfectGas1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged1
    multiplexer3.setInputValues(0, perfectGas1.getEntropy());
    multiplexer3.setInputValues(1, perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged1
  
  private void multiplexer2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer2ValueChanged
    xYScope1.setInputVector(multiplexer2.getOutputVector());
  }//GEN-LAST:event_multiplexer2ValueChanged
  
  private void perfectGas1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged
    multiplexer2.setInputValues(0, perfectGas1.getVolume());
    multiplexer2.setInputValues(1, perfectGas1.getPressure());
  }//GEN-LAST:event_perfectGas1SourceChanged
          
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    cyclicProcess1.setStartPressure(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
    xYScope2.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    cyclicProcess1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    cyclicProcess1.nextStep();
    multiplexer2.trigger();
    multiplexer3.trigger();
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.CyclicProcess cyclicProcess1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.func.Multiplexer multiplexer2;
  protected physbeans.func.Multiplexer multiplexer3;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PerfectGas perfectGas1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSliderN;
  protected physbeans.inout.VectorSlider vectorSliderV;
  protected physbeans.inout.XYScope xYScope1;
  protected physbeans.inout.XYScope xYScope2;
// End of variables declaration//GEN-END:variables
  
}
